<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>List Users</title>
</head>

<body>
    <div class="container">
        <h2 class="text-center my-4">Danh sách người dùng đăng ký</h2>
        <button style="margin-bottom: 20px;" class="btn btn-success">Thêm user</button>
        <table id="table-users" class="table table-striped table-bordered table-hover">
            <thead class="thead-dark">
                <tr>
                    <th scope="col">ID</th>
                    <th scope="col">Firstname</th>
                    <th scope="col">Lastname</th>
                    <th scope="col">Country</th>
                    <th scope="col">Subject</th>
                    <th scope="col">Customer Type</th>
                    <th scope="col">Register Status</th>
                    <th scope="col">Action</th>
                </tr>
            </thead>
            <tbody id="table-body">

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gCOLUM_ID = 0
    const gCOLUM_FIRSTNAME = 1
    const gCOLUM_LASTNAME = 2
    const gCOLUM_COUNTRY = 3
    const gCOLUM_SUBJECT = 4
    const gCOLUM_CUSTOMER_TYPE = 5
    const gCOLUM_REGISTER_STATUS = 6
    const gCOLUM_ACTIONS = 7
    const gEND_OF_ROW_COL = -1;
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading()
        $("#table-body").on("click", ".edit-user", function () {
            onBtnEditUserClick(this)
        })
        $("#table-body").on("click", ".delete-user", function () {
            onBtnDeleteUserClick(this)
        })
        $(".btn-success").on("click", function () {
            window.location.href = "insertUser.html"
        })
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            dataType: "json",
            success: function (res) {
                loadDataToTable(res)
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText)
            }
        })
    }
    // Hàm xử lý sự kiện nút sửa click
    function onBtnEditUserClick(paramElement) {
        var vUserId = $(paramElement).data("id")
        console.log(vUserId)
        var vDetailUser = "updateUser.html" + "?id=" + vUserId
        window.location.href = vDetailUser
    }
    function onBtnDeleteUserClick(paramElement) {
        var vUserId = $(paramElement).data("id")


        if (confirm("Xóa user này ?") == true) {
            console.log(vUserId);
            $.ajax({
                url: gBASE_URL + vUserId,
                type: "Delete",
                dataType: "json",
                success: updateUser,
                error: processError,

            })
        } else {

        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm điền thông tin vào bảng
    function loadDataToTable(paramResponseObject) {
        var vTBody = $("#table-body")
        for (var bI = 0; bI < paramResponseObject.length; bI++) {
            // Thêm 1 hàng vào bảng
            var bNewRow = vTBody.append($("<tr>"))
            // Thêm các ô vào bảng
            bNewRow.append($("<td>", { html: paramResponseObject[bI].id }))
            bNewRow.append($("<td>", { html: paramResponseObject[bI].firstname }))
            bNewRow.append($("<td>", { html: paramResponseObject[bI].lastname }))
            bNewRow.append($("<td>", { html: paramResponseObject[bI].country }))
            bNewRow.append($("<td>", { html: paramResponseObject[bI].subject }))
            bNewRow.append($("<td>", { html: paramResponseObject[bI].customerType }))
            bNewRow.append($("<td>", { html: paramResponseObject[bI].registerStatus }))

            // ô action
            var bActionCell = $("<td>").appendTo(bNewRow);
            //Nút sửa
            $("<button>", {
                html: "Sửa",
                class: "btn btn-primary edit-user"
            }).data("id", paramResponseObject[bI].id)
                .appendTo(bActionCell)
            //Nút xóa
            $("<button>", {
                html: "Xóa",
                class: "btn btn-danger delete-user"
            }).data("id", paramResponseObject[bI].id)
                .appendTo(bActionCell)
        }
    }

    // Hàm hiển thị khi update thành công
    function updateUser(paramResponse) {
        console.log(paramResponse)
        alert("Xóa user thành công")
        location.reload()
    }
    // Hàm hiển thị khi gặp lỗi
    function processError(paramAjaxContext) {
        console(paramAjaxContext.responseText)
        alert("Vui lòng thử lại sau")
    }
</script>

</html>